package cn.ibizlab.businesscentral.core.rest;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import lombok.extern.slf4j.Slf4j;
import com.alibaba.fastjson.JSONObject;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;
import org.springframework.context.annotation.Lazy;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.access.prepost.PostAuthorize;
import org.springframework.validation.annotation.Validated;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
import cn.ibizlab.businesscentral.core.dto.*;
import cn.ibizlab.businesscentral.core.mapping.*;
import cn.ibizlab.businesscentral.core.odoo_base_import.domain.Base_import_tests_models_char_noreadonly;
import cn.ibizlab.businesscentral.core.odoo_base_import.service.IBase_import_tests_models_char_noreadonlyService;
import cn.ibizlab.businesscentral.core.odoo_base_import.filter.Base_import_tests_models_char_noreadonlySearchContext;
import cn.ibizlab.businesscentral.util.annotation.VersionCheck;

@Slf4j
@Api(tags = {"测试:基本导入模型，字符无只读" })
@RestController("Core-base_import_tests_models_char_noreadonly")
@RequestMapping("")
public class Base_import_tests_models_char_noreadonlyResource {

    @Autowired
    public IBase_import_tests_models_char_noreadonlyService base_import_tests_models_char_noreadonlyService;

    @Autowired
    @Lazy
    public Base_import_tests_models_char_noreadonlyMapping base_import_tests_models_char_noreadonlyMapping;

    @PreAuthorize("hasPermission(this.base_import_tests_models_char_noreadonlyMapping.toDomain(#base_import_tests_models_char_noreadonlydto),'iBizBusinessCentral-Base_import_tests_models_char_noreadonly-Create')")
    @ApiOperation(value = "新建测试:基本导入模型，字符无只读", tags = {"测试:基本导入模型，字符无只读" },  notes = "新建测试:基本导入模型，字符无只读")
	@RequestMapping(method = RequestMethod.POST, value = "/base_import_tests_models_char_noreadonlies")
    public ResponseEntity<Base_import_tests_models_char_noreadonlyDTO> create(@Validated @RequestBody Base_import_tests_models_char_noreadonlyDTO base_import_tests_models_char_noreadonlydto) {
        Base_import_tests_models_char_noreadonly domain = base_import_tests_models_char_noreadonlyMapping.toDomain(base_import_tests_models_char_noreadonlydto);
		base_import_tests_models_char_noreadonlyService.create(domain);
        Base_import_tests_models_char_noreadonlyDTO dto = base_import_tests_models_char_noreadonlyMapping.toDto(domain);
		return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

    @PreAuthorize("hasPermission(this.base_import_tests_models_char_noreadonlyMapping.toDomain(#base_import_tests_models_char_noreadonlydtos),'iBizBusinessCentral-Base_import_tests_models_char_noreadonly-Create')")
    @ApiOperation(value = "批量新建测试:基本导入模型，字符无只读", tags = {"测试:基本导入模型，字符无只读" },  notes = "批量新建测试:基本导入模型，字符无只读")
	@RequestMapping(method = RequestMethod.POST, value = "/base_import_tests_models_char_noreadonlies/batch")
    public ResponseEntity<Boolean> createBatch(@RequestBody List<Base_import_tests_models_char_noreadonlyDTO> base_import_tests_models_char_noreadonlydtos) {
        base_import_tests_models_char_noreadonlyService.createBatch(base_import_tests_models_char_noreadonlyMapping.toDomain(base_import_tests_models_char_noreadonlydtos));
        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

    @VersionCheck(entity = "base_import_tests_models_char_noreadonly" , versionfield = "writeDate")
    @PreAuthorize("hasPermission(this.base_import_tests_models_char_noreadonlyService.get(#base_import_tests_models_char_noreadonly_id),'iBizBusinessCentral-Base_import_tests_models_char_noreadonly-Update')")
    @ApiOperation(value = "更新测试:基本导入模型，字符无只读", tags = {"测试:基本导入模型，字符无只读" },  notes = "更新测试:基本导入模型，字符无只读")
	@RequestMapping(method = RequestMethod.PUT, value = "/base_import_tests_models_char_noreadonlies/{base_import_tests_models_char_noreadonly_id}")
    public ResponseEntity<Base_import_tests_models_char_noreadonlyDTO> update(@PathVariable("base_import_tests_models_char_noreadonly_id") Long base_import_tests_models_char_noreadonly_id, @RequestBody Base_import_tests_models_char_noreadonlyDTO base_import_tests_models_char_noreadonlydto) {
		Base_import_tests_models_char_noreadonly domain  = base_import_tests_models_char_noreadonlyMapping.toDomain(base_import_tests_models_char_noreadonlydto);
        domain .setId(base_import_tests_models_char_noreadonly_id);
		base_import_tests_models_char_noreadonlyService.update(domain );
		Base_import_tests_models_char_noreadonlyDTO dto = base_import_tests_models_char_noreadonlyMapping.toDto(domain );
        return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

    @PreAuthorize("hasPermission(this.base_import_tests_models_char_noreadonlyService.getBaseImportTestsModelsCharNoreadonlyByEntities(this.base_import_tests_models_char_noreadonlyMapping.toDomain(#base_import_tests_models_char_noreadonlydtos)),'iBizBusinessCentral-Base_import_tests_models_char_noreadonly-Update')")
    @ApiOperation(value = "批量更新测试:基本导入模型，字符无只读", tags = {"测试:基本导入模型，字符无只读" },  notes = "批量更新测试:基本导入模型，字符无只读")
	@RequestMapping(method = RequestMethod.PUT, value = "/base_import_tests_models_char_noreadonlies/batch")
    public ResponseEntity<Boolean> updateBatch(@RequestBody List<Base_import_tests_models_char_noreadonlyDTO> base_import_tests_models_char_noreadonlydtos) {
        base_import_tests_models_char_noreadonlyService.updateBatch(base_import_tests_models_char_noreadonlyMapping.toDomain(base_import_tests_models_char_noreadonlydtos));
        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

    @PreAuthorize("hasPermission(this.base_import_tests_models_char_noreadonlyService.get(#base_import_tests_models_char_noreadonly_id),'iBizBusinessCentral-Base_import_tests_models_char_noreadonly-Remove')")
    @ApiOperation(value = "删除测试:基本导入模型，字符无只读", tags = {"测试:基本导入模型，字符无只读" },  notes = "删除测试:基本导入模型，字符无只读")
	@RequestMapping(method = RequestMethod.DELETE, value = "/base_import_tests_models_char_noreadonlies/{base_import_tests_models_char_noreadonly_id}")
    public ResponseEntity<Boolean> remove(@PathVariable("base_import_tests_models_char_noreadonly_id") Long base_import_tests_models_char_noreadonly_id) {
         return ResponseEntity.status(HttpStatus.OK).body(base_import_tests_models_char_noreadonlyService.remove(base_import_tests_models_char_noreadonly_id));
    }

    @PreAuthorize("hasPermission(this.base_import_tests_models_char_noreadonlyService.getBaseImportTestsModelsCharNoreadonlyByIds(#ids),'iBizBusinessCentral-Base_import_tests_models_char_noreadonly-Remove')")
    @ApiOperation(value = "批量删除测试:基本导入模型，字符无只读", tags = {"测试:基本导入模型，字符无只读" },  notes = "批量删除测试:基本导入模型，字符无只读")
	@RequestMapping(method = RequestMethod.DELETE, value = "/base_import_tests_models_char_noreadonlies/batch")
    public ResponseEntity<Boolean> removeBatch(@RequestBody List<Long> ids) {
        base_import_tests_models_char_noreadonlyService.removeBatch(ids);
        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

    @PostAuthorize("hasPermission(this.base_import_tests_models_char_noreadonlyMapping.toDomain(returnObject.body),'iBizBusinessCentral-Base_import_tests_models_char_noreadonly-Get')")
    @ApiOperation(value = "获取测试:基本导入模型，字符无只读", tags = {"测试:基本导入模型，字符无只读" },  notes = "获取测试:基本导入模型，字符无只读")
	@RequestMapping(method = RequestMethod.GET, value = "/base_import_tests_models_char_noreadonlies/{base_import_tests_models_char_noreadonly_id}")
    public ResponseEntity<Base_import_tests_models_char_noreadonlyDTO> get(@PathVariable("base_import_tests_models_char_noreadonly_id") Long base_import_tests_models_char_noreadonly_id) {
        Base_import_tests_models_char_noreadonly domain = base_import_tests_models_char_noreadonlyService.get(base_import_tests_models_char_noreadonly_id);
        Base_import_tests_models_char_noreadonlyDTO dto = base_import_tests_models_char_noreadonlyMapping.toDto(domain);
        return ResponseEntity.status(HttpStatus.OK).body(dto);
    }


}

